#include <QString>
#include "sivia.h"
#include "window.h"

using namespace std;

#include "syntax_tree.h"
#include "frame.h"
extern QString fonction;
extern double precision;
extern Frame *pavage1;


Interval f(Box& X)
{   return Eval(X);};


Iboolean Inside (Box& X)
{   Interval Y(-99999999,0);
    Interval Ym=f(X);
    return (Ym.isIn(Y));
};


void siviaFile (Box& X)
{   list<Box> L;
    L.push_back (X);
    pavage1->clear();
    while ( !L.empty() )
    {   X=L.front();   L.pop_front();
        Iboolean test=Inside (X);
        if (X.width()<precision)   pavage1->addBox(X,QColor("Yellow"));
        else if ( test==itrue )    pavage1->addBox(X,QColor("Red"));
        else if (test==ifalse)     pavage1->addBox(X,QColor("Cyan"));
        else
        {   Box X1(2);  Box X2(2);
            Bisect (X,X1,X2 );
            L.push_back(X1);  L.push_back(X2);
        }
    }
}

